/*

IFT1169 - Fonctions Amies - Exemple 02 -

01-octobre	- 2016 v1.04	M.Lokbani - GCC 6.2 avec -std=c++11
25-octobre	- 2014 v1.03	M.Lokbani - GCC 4.9.1 avec -std=c++11
05-novembre	- 2013 v1.02	M.Lokbani - GCC 4.8.1 avec -std=c++11
21-janvier	- 2006 v1.01	M.Lokbani - GCC3.4.2.
18-octobre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2016 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------
    L'amitié sous tous les angles.
    
    Voir notes de cours, 3: Fonction membre d'une classe, amie d'une autre classe.

*/


#include <iostream>
using namespace std;

// déclaration de la classe A, le compilateur connaît maintenant l'existence de la classe A.
class A;
class B { // définition de la classe B.
public:
	/*
		la fonction exemple est uniquement déclarée. Comme argument, elle prend une
		référence à un objet de la classe A. On ne peut pas définir la fonction exemple
		à ce niveau, car si elle utilise un membre donnée de la classe A, sachant que A
		n'a pas été encore définie, on aura des problèmes à la compilation.
	*/

	void exemple (A&);
    
};
class A { // définition de la classe A
	int i;
	// on connaît déjà le contenu de la classe B, exemple est une fonction
	// membre de cette classe, elle est déclarée aussi à ce niveau comme amie
	// de la classe A. Elle aura donc accès aux données privées de la classe A.
	friend void B::exemple (A&);
public:
	// constructeur qui initialise i à la valeur de e, par défaut 100.
	A(int e=100):i(e) {}
};

// A & B étant définies, on peut définir la fonction exemple.
void B::exemple (A& a) {
	cout << a.i << endl;
}
int main() {
	A x;
	B y;
	y.exemple(x); // en sortie: 100
	return 0;
}


/*
    >amies2
    100
    >Exit code: 0
*/
