/*

IFT1169 - Fonctions Amies - Exemple 03 -

01-octobre	- 2016 v1.04	M.Lokbani - GCC 6.2 avec -std=c++11
25-octobre	- 2014 v1.03	M.Lokbani - GCC 4.9.1 avec -std=c++11
05-novembre	- 2013 v1.02	M.Lokbani - GCC 4.8.1 avec -std=c++11
21-janvier	- 2006 v1.01	M.Lokbani - GCC3.4.2.
18-octobre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2016 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------
    L'amitié sous tous les angles.
    
    Voir notes de cours, 4: Classe amie d'une autre classe.

*/

#include <iostream>
using namespace std;


class A; // déclaration de la classe A.

class B { // définition de la classe B.
public:
	void change (A&);
	void affiche(A&);
};

class A {
	int i;
	// la classe B est amie la classe A. De ce fait, les fonctions membres
	// de la classe B c.-à-d. (change & affiche) sont amies de la classe A.
	friend class B;
public:
	A(int e=100):i(e) {} // constructeur.
};

// définition de change, fonction membre de la classe B.
void B::change(A& a) {
	a.i = 200;
}

// définition de affiche, fonction membre de la classe B.
void B::affiche(A& a) {
	cout << a.i << endl;
}


int main() {
	A x;
	B y;
	y.affiche(x); // en sortie: 100
	y.change(x);
	y.affiche(x); // en sortie: 200
	return 0;
}

/*
    >amies3
    100
    200
    >Exit code: 0
*/
