/*

IFT1169 - Fonctions Amies - Exemple 04 -

01-octobre	- 2016 v1.04	M.Lokbani - GCC 6.2 avec -std=c++11
25-octobre	- 2014 v1.03	M.Lokbani - GCC 4.9.1 avec -std=c++11
05-novembre	- 2013 v1.02	M.Lokbani - GCC 4.8.1 avec -std=c++11
21-janvier	- 2006 v1.01	M.Lokbani - GCC3.4.2.
18-octobre	- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2016 Université de Montréal
            Département d'informatique et de Recherche Opérationnelle
            Mohamed Lokbani
    -- Tous Droits Réservés -- All Rights Reserved --

Description:
------------
    L'amitié sous tous les angles.
    
    Voir notes de cours, 5: Fonction amie de plusieurs classes.

*/

#include <iostream>

using namespace std;

 // déclaration de A. (Nous pouvions déclarer B en premier).
class A;

// définition de B (dans le cas ou la classe B a été déclarée en 1er, nous aurions défini A à ce niveau).
class B {
	int j;
public:
	// fonction amie de deux classes A & B.
	friend void affiche(A&,B&);
	B(int w=999):j(w){} // constructeur: j=w, par défaut j=999.
};


// définition de A (Si la classe B a été déclarée en 1er, nous aurions défini B à ce niveau).
class A {
	int i;
	friend void affiche(A&,B&); // fonctions amies de deux classes A & B.
public:
	A(int e=555):i(e) {} // constructeur: i=e, par défaut i=555.
};

// définition de la fonction amie affiche.
void affiche(A& a,B& b) {
	cout << "A:i " << a.i << endl;
	cout << "B:j " << b.j << endl;
}

int main() {
	A x;
	B y;
	affiche(x,y); // en sortie 

	return 0;
}

/*
        >amies4
        A:i 555
        B:j 999
        >Exit code: 0
*/
